/**
 * @(#)BarRenderer.java  12/12/99
 * @author Peter Au
 * All rights reserved.
 */

package vishnu.testvis.treemap.table;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.TableCellRenderer;

//!!! the % in getString and getColor may WRONG !!!

public class BarRenderer extends JProgressBar implements TableCellRenderer
{

  public BarRenderer(){
    super(JProgressBar.HORIZONTAL);
    setBorderPainted(false);
    this.setFont(new Font("Arial",Font.PLAIN,9));
  }


  public BarRenderer(int min, int max){
    super(min,max);
    setBorderPainted(false);
    this.setFont(new Font("Arial",Font.PLAIN,9));
  }

  public String getString(){
    if (getValue()==0) return "";
    else return String.valueOf(getValue())+"%";
  }

  public Component getTableCellRendererComponent(JTable table, Object value,
    boolean isSelected, boolean hasFocus, int row, int column){
  int n = 0;
    if (value instanceof Number){
      n = ((Number) value).intValue();
    } else{
      System.err.println("Error - item in bar render is not a number");
    }
    setValue(n);
    setForeground(getColor(n));
    return this;
  }

  private Color getColor(int value){
    if (value < 40) return Color.green;
    else if (value <80) return Color.yellow;
    else
      return Color.red;
  }

}
